## GitLab URL
##! URL on which GitLab will be reachable.
##! For more details on configuring external_url see:
##! https://docs.gitlab.com/omnibus/settings/configuration.html#configuring-the-external-url-for-gitlab
##!
##! Note: During installation/upgrades, the value of the environment variable
##! EXTERNAL_URL will be used to populate/replace this value.
##! On AWS EC2 instances, we also attempt to fetch the public hostname/IP
##! address from AWS. For more details, see:
##! https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html
external_url 'https://{{ external_url }}'

## Roles for multi-instance GitLab
##! The default is to have no roles enabled, which results in GitLab running as an all-in-one instance.
##! Options:
##!   redis_sentinel_role redis_master_role redis_slave_role geo_primary_role geo_secondary_role
##! For more details on each role, see:
##! https://docs.gitlab.com/omnibus/roles/README.html#roles
##!
# roles ['redis_sentinel_role', 'redis_master_role']
{% if host_roles is defined and host_roles|length %}
roles ["{{ host_roles | join('", "')}}"]
{% endif %}

consul['enable'] = {{ consul_enable }}

################################################################################
## GitLab NGINX
##! Docs: https://docs.gitlab.com/omnibus/settings/nginx.html
################################################################################
nginx['enable'] = {{ nginx_enable }}
{% if nginx_enable == "true" %}
nginx['client_max_body_size'] = '{{ client_max_body_size }}'
{% if redirect_http_to_https and redirect_http_to_https|length %}
nginx['redirect_http_to_https'] = {{ redirect_http_to_https }}
nginx['redirect_http_to_https_port'] = {{ redirect_http_to_https_port }}
{% endif %}

{% if ssl_client_certificate is defined and ssl_client_certificate|length %}
##! Most root CA's are included by default
nginx['ssl_client_certificate'] = "{{ ssl_client_certificate }}"

{% endif %}
{% if ssl_verify_client == "on" %}
##! enable/disable 2-way SSL client authentication
nginx['ssl_verify_client'] = "{{ ssl_verify_client }}"

##! if ssl_verify_client on, verification depth in the client certificates chain
nginx['ssl_verify_depth'] = "{{ ssl_verify_depth }}"

{% endif %}

nginx['ssl_certificate'] = "{{ ssl_certificate }}"
nginx['ssl_certificate_key'] = "{{ ssl_certificate_key }}"
nginx['ssl_ciphers'] = "{{ ssl_ciphers | join (':')}}"
nginx['ssl_prefer_server_ciphers'] = "{{ ssl_prefer_server_ciphers }}"

##! **Recommended by: https://raymii.org/s/tutorials/Strong_SSL_Security_On_nginx.html
##!                   https://cipherli.st/**
nginx['ssl_protocols'] = "{{ ssl_protocols | join(' ')}}"

##! **Recommended in: https://nginx.org/en/docs/http/ngx_http_ssl_module.html**
nginx['ssl_session_cache'] = "{{ ssl_session_cache | join(' ')}}"

##! **Default according to https://nginx.org/en/docs/http/ngx_http_ssl_module.html**
nginx['ssl_session_timeout'] = "{{ ssl_session_timeout }}"

# nginx['ssl_dhparam'] = nil # Path to dhparams.pem, eg. /etc/gitlab/ssl/dhparams.pem
nginx['listen_addresses'] = ["{{ listen_addresses | join('", "')}}"]

##! **Defaults to forcing web browsers to always communicate using only HTTPS**
##! Docs: https://docs.gitlab.com/omnibus/settings/nginx.html#setting-http-strict-transport-security
nginx['hsts_max_age'] = {{ hsts_max_age }}
nginx['hsts_include_subdomains'] = {{ hsts_include_subdomains }}

##! Defaults to stripping path information when making cross-origin requests
nginx['referrer_policy'] = '{{ referrer_policy }}'

##! **Docs: http://nginx.org/en/docs/http/ngx_http_gzip_module.html**
nginx['gzip_enabled'] = {{ gzip_enabled }}

##! **Override only if you use a reverse proxy**
##! Docs: https://docs.gitlab.com/omnibus/settings/nginx.html#setting-the-nginx-listen-port
# nginx['listen_port'] = nil

##! **Override only if your reverse proxy internally communicates over HTTP**
##! Docs: https://docs.gitlab.com/omnibus/settings/nginx.html#supporting-proxied-ssl
# nginx['listen_https'] = nil

# nginx['custom_gitlab_server_config'] = "location ^~ /foo-namespace/bar-project/raw/ {\n deny all;\n}\n"
# nginx['custom_nginx_config'] = "include /etc/nginx/conf.d/example.conf;"
{% if proxy_set_headers is defined and proxy_set_headers|length %}
nginx['proxy_set_headers'] = {
{% for key, value in proxy_set_headers.items() %}
  "{{ key }}" => "{{ value }}",
{% endfor %}
}
{% endif %}
nginx['http2_enabled'] = {{ http2_enabled }}
{% if real_ip_trusted_addresses is defined and real_ip_trusted_addresses|length %}
# Each address is added to the the NGINX config as 'set_real_ip_from <address>;'
nginx['real_ip_trusted_addresses'] = ["{{ real_ip_trusted_addresses | join('", "') }}"]
{% endif %}
# nginx['real_ip_header'] = nil
# nginx['real_ip_recursive'] = nil
# nginx['custom_error_pages'] = {
#   '404' => {
#     'title' => 'Example title',
#     'header' => 'Example header',
#     'message' => 'Example message'
#   }
# }

### Advanced settings
nginx['dir'] = "{{ nginx_dir }}"
nginx['log_directory'] = "{{ nginx_log_directory }}"
nginx['worker_processes'] = {{ worker_processes }}
nginx['worker_connections'] = {{ worker_connections }}
nginx['log_format'] = '{{ log_format }}'
nginx['sendfile'] = '{{ sendfile }}'
nginx['tcp_nopush'] = '{{ tcp_nopush }}'
nginx['tcp_nodelay'] = '{{ tcp_nodelay }}'
nginx['gzip_http_version'] = "{{ gzip_http_version }}"
nginx['gzip_comp_level'] = "{{ gzip_comp_level }}"
nginx['gzip_proxied'] = "{{ gzip_proxied }}"
nginx['gzip_types'] = [ "{{ gzip_types | join('", "') }}" ]
nginx['keepalive_timeout'] = {{ keepalive_timeout }}
nginx['cache_max_size'] = '{{ cache_max_size }}'
nginx['server_names_hash_bucket_size'] = {{ server_names_hash_bucket_size }}
##! These paths have proxy_request_buffering disabled
nginx['request_buffering_off_path_regex'] = "{{ request_buffering_off_path_regex }}"
nginx['custom_gitlab_server_config'] = "add_header NodeName {{ inventory_hostname }};"

### Nginx status
# nginx['status'] = {
#  "enable" => true,
#  "listen_addresses" => ["127.0.0.1"],
#  "fqdn" => "dev.example.com",
#  "port" => 9999,
#  "vts_enable" => true,
#  "options" => {
#    "stub_status" => "on", # Turn on stats
#    "server_tokens" => "off", # Don't show the version of NGINX
#    "access_log" => "off", # Disable logs for stats
#    "allow" => "127.0.0.1", # Only allow access from localhost
#    "deny" => "all" # Deny access to anyone else
#  }
# }
{% endif %}

################################################################################
## LetsEncrypt Integration
##! Docs: https://docs.gitlab.com/omnibus/settings/ssl.html#lets-encrypt-integration
################################################################################
letsencrypt['enable'] = {{ letsencrypt_enabled }}

################################################################################
## GitLab User Settings
##! Modify default git user.
##! Docs: https://docs.gitlab.com/omnibus/settings/configuration.html#changing-the-name-of-the-git-user-group
################################################################################
user['username'] = "{{ git_username }}"
user['group'] = "{{ git_group }}"
user['uid'] = {{ git_uid }}
user['gid'] = {{ git_gid }}
user['shell'] = "{{ git_shell }}"
user['home'] = "{{ git_home }}"
user['git_user_name'] = "{{ git_user_name }}"
user['git_user_email'] = "{{ git_user_email }}"

################################################################################
## gitlab.yml configuration
##! Docs: https://gitlab.com/gitlab-org/omnibus-gitlab/blob/master/doc/settings/gitlab.yml.md
################################################################################
###! IP whitelist controlling access to monitoring endpoints
gitlab_rails['monitoring_whitelist'] = ["{{ gitlab_rails_monitoring_whitelist | join('", "') }}"]

################################################################################
## Git
##! Advanced setting for configuring git system settings for omnibus-gitlab
##! internal git
################################################################################

gitaly['configuration'] = {
  git: {
    config: [
{% for key, value in advanced_git_config.items() %}
      { key: "{{ key }}", value: "0" },
{% endfor %}
    ],
  },
}

#######################################
###            Backup               ###
#######################################
gitlab_rails['backup_keep_time'] = {{ backup_keep_time }}
gitlab_rails['backup_path'] = '{{ backup_path }}'

#######################################
###            Postgres             ###
#######################################
postgresql['enable'] = {{ postgresql_enable }}
{% if postgresql_enable == "false" %}
### GitLab database settings
###! Docs: https://docs.gitlab.com/omnibus/settings/database.html
###! **Only needed if you use an external database.**
gitlab_rails['db_adapter'] = "{{ db_adapter }}"
gitlab_rails['db_encoding'] = "{{ db_encoding }}"
gitlab_rails['db_collation'] = {{ db_collation }}
#gitlab_rails['db_database'] = "{{ db_database }}"
gitlab_rails['db_pool'] = {{ db_pool }}
#gitlab_rails['db_username'] = "{{ db_username }}"
gitlab_rails['db_password'] = "{{ db_password }}"
gitlab_rails['db_host'] = "{{ db_host }}"
gitlab_rails['db_port'] = {{ db_port }}
gitlab_rails['db_socket'] = {{ db_socket }}
gitlab_rails['db_sslmode'] = {{ db_sslmode }}
gitlab_rails['db_sslcompression'] = {{ db_sslcompression }}
gitlab_rails['db_sslrootcert'] = {{ db_sslrootcert }}
gitlab_rails['db_sslcert'] = {{ db_sslcert }}
gitlab_rails['db_sslkey'] = {{ db_sslkey }}
gitlab_rails['db_prepared_statements'] = {{ db_prepared_statements }}
gitlab_rails['db_statements_limit'] = {{ db_statements_limit }}
# Prevent database migrations from running on upgrade automatically
gitlab_rails['auto_migrate'] = {{ db_auto_migrate }}
{% endif %}

{% if object_store_enabled == "true" %}
#############################
###     Object storage    ###
#############################
### Job Artifacts
gitlab_rails['artifacts_enabled'] = {{ object_store_enabled }}
gitlab_rails['artifacts_path'] = "{{ gitlab_rails_dir }}/shared/artifacts"
gitlab_rails['artifacts_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['artifacts_object_store_proxy_download'] = {{ object_store_proxy_download }}
gitlab_rails['artifacts_object_store_remote_directory'] = "{{ object_store_buckets.artifacts }}"
gitlab_rails['artifacts_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### External merge request diffs
gitlab_rails['external_diffs_enabled'] = {{ object_store_enabled }}
gitlab_rails['external_diffs_when'] = "outdated"
gitlab_rails['external_diffs_storage_path'] = "{{ gitlab_rails_dir }}/shared/external-diffs"
gitlab_rails['external_diffs_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['external_diffs_object_store_proxy_download'] = {{ object_store_proxy_download }}
gitlab_rails['external_diffs_object_store_remote_directory'] = "{{ object_store_buckets.external_diffs }}"
gitlab_rails['external_diffs_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### Git LFS
gitlab_rails['lfs_enabled'] = {{ object_store_enabled }}
gitlab_rails['lfs_storage_path'] = "{{ gitlab_rails_dir }}/shared/lfs-objects"
gitlab_rails['lfs_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['lfs_object_store_proxy_download'] = {{ object_store_proxy_download }}
gitlab_rails['lfs_object_store_remote_directory'] = "{{ object_store_buckets.lfs }}"
gitlab_rails['lfs_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### GitLab uploads
gitlab_rails['uploads_storage_path'] = "/opt/gitlab/embedded/service/gitlab-rails/public"
gitlab_rails['uploads_base_dir'] = "uploads/-/system"
gitlab_rails['uploads_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['uploads_object_store_proxy_download'] = {{ object_store_proxy_download }}
gitlab_rails['uploads_object_store_remote_directory'] = "{{ object_store_buckets.uploads }}"
gitlab_rails['uploads_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### GitLab Terraform State Store
gitlab_rails['terraform_state_storage_path'] = "{{ gitlab_rails_dir }}/shared/terraform_state"
gitlab_rails['terraform_state_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['terraform_state_object_store_remote_directory'] = "{{ object_store_buckets.terraform_state }}"
gitlab_rails['terraform_state_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### GitLab Dependency Proxy
gitlab_rails['dependency_proxy_enabled'] = {{ object_store_enabled }}
gitlab_rails['dependency_proxy_storage_path'] = "{{ gitlab_rails_dir }}/shared/dependency_proxy"
gitlab_rails['dependency_proxy_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['dependency_proxy_object_store_remote_directory'] = "{{ object_store_buckets.dependency_proxy }}"
gitlab_rails['dependency_proxy_object_store_proxy_download'] = {{ object_store_proxy_download }}
gitlab_rails['dependency_proxy_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### GitLab Package Store
gitlab_rails['packages_enabled'] = {{ object_store_enabled }}
gitlab_rails['packages_object_store_enabled'] = {{ object_store_enabled }}
gitlab_rails['packages_object_store_remote_directory'] = "{{ object_store_buckets.packages }}" # The bucket name.
gitlab_rails['packages_object_store_proxy_download'] = {{ object_store_proxy_download }}        # Passthrough all downloads via GitLab instead of using Redirects to Object Storage.
gitlab_rails['packages_object_store_connection'] = {
  'provider' => '{{ object_store_connection.provider }}',
  'region' => '{{ object_store_connection.region }}',
  'aws_access_key_id' => '{{ object_store_connection.aws_access_key_id }}',
  'aws_secret_access_key' => '{{ object_store_connection.aws_secret_access_key }}',
}

### Consolidated object storage configuration
#gitlab_rails['object_store']['enabled'] = {{ object_store_enabled }}
#gitlab_rails['object_store']['proxy_download'] = {{ object_store_proxy_download }}
#gitlab_rails['object_store']['connection'] = {
#{% for key, value in object_store_connection.items() %}
#  '{{ key }}' => '{{ value }}',
#{% endfor %}
#}
#{% if object_store_storage_options is defined and object_store_storage_options| length %}
#{% for key, value in object_store_storage_options.items() %}
#  '{{ key }}' => '{{ value }}',
#{% endfor %}
#{% endif %}
#{% for key, value in object_store_buckets.items() %}
#gitlab_rails['object_store']['objects']['{{ key }}']['bucket'] = '{{ value }}'
#{% endfor %}
#{% endif %}

### For setting up different data storing directory
###! Docs: https://docs.gitlab.com/omnibus/settings/configuration.html#storing-git-data-in-an-alternative-directory
###! **If you want to use a single non-default directory to store git data use a
###!   path that doesn't contain symlinks.**
###! git_data_dirs get configured for the Praefect virtual storage
###! Address is Interal Load Balancer for Praefect
###! Token is praefect_external_token
git_data_dirs({
{% for key, value in git_data_dirs.items() %}
  "{{ key }}" => {
{% for key,value in value.items() %}
    "{{ key }}" => "{{ value }}",
{% endfor %}
   },
{% endfor %}
})

### LDAP Settings
###! Docs: https://docs.gitlab.com/omnibus/settings/ldap.html
###! **Be careful not to break the indentation in the ldap_servers block. It is
###!   in yaml format and the spaces must be retained. Using tabs will not work.**

gitlab_rails['ldap_enabled'] = {{ ldap_enabled }}
{% if ldap_enabled == "true" %}
gitlab_rails['prevent_ldap_sign_in'] = {{ prevent_ldap_sign_in }}

###! **remember to close this block with 'EOS' below**
gitlab_rails['ldap_servers'] = YAML.load <<-'EOS'
  main: # 'main' is the GitLab 'provider ID' of this LDAP server
    label: '{{ ldap_servers.main.label }}'
    host: '{{ ldap_servers.main.host }}'
    port: {{ ldap_servers.main.port }}
    uid: '{{ ldap_servers.main.uid }}'
    bind_dn: '{{ ldap_servers.main.bind_dn }}'
    password: '{{ ldap_servers.main.password }}'
    encryption: '{{ ldap_servers.main.encryption }}' # "start_tls" or "simple_tls" or "plain"
    verify_certificates: {{ ldap_servers.main.verify_certificates }}
    smartcard_auth: {{ ldap_servers.main.smartcard_auth }}
    active_directory: {{ ldap_servers.main.active_directory }}
    allow_username_or_email_login: {{ ldap_servers.main.allow_username_or_email_login }}
    lowercase_usernames: {{ ldap_servers.main.lowercase_usernames }}
    block_auto_created_users: {{ ldap_servers.main.block_auto_created_users }}
    base: '{{ ldap_servers.main.base }}'
    user_filter: '{{ ldap_servers.main.user_filter }}'
    ## EE only
#     group_base: ''
#     admin_group: ''
#     sync_ssh_keys: false
#
{% if ldap_servers.secondary.enabled %}
  secondary: # 'secondary' is the GitLab 'provider ID' of second LDAP server
    label: '{{ ldap_servers.secondary.label }}'
    host: '{{ ldap_servers.secondary.host }}'
    port: {{ ldap_servers.secondary.port }}
    uid: '{{ ldap_servers.secondary.uid }}'
    bind_dn: '{{ ldap_servers.secondary.bind_dn }}'
    password: '{{ ldap_servers.secondary.password }}'
    encryption: '{{ ldap_servers.secondary.encryption }}' # "start_tls" or "simple_tls" or "plain"
    verify_certificates: {{ ldap_servers.secondary.verify_certificates }}
    smartcard_auth: {{ ldap_servers.secondary.smartcard_auth }}
    active_directory: {{ ldap_servers.secondary.active_directory }}
    allow_username_or_email_login: {{ ldap_servers.secondary.allow_username_or_email_login }}
    lowercase_usernames: {{ ldap_servers.secondary.lowercase_usernames }}
    block_auto_created_users: {{ ldap_servers.secondary.block_auto_created_users }}
    base: '{{ ldap_servers.secondary.base }}'
    user_filter: '{{ ldap_servers.secondary.user_filter }}'
#     ## EE only
#     group_base: ''
#     admin_group: ''
#     sync_ssh_keys: false
{% endif %}
EOS
{% endif %}

### OmniAuth Settings
####! Docs: https://docs.gitlab.com/ee/integration/omniauth.html
gitlab_rails['omniauth_enabled'] = {{ omniauth_enabled }}

### GitLab email server settings
###! Docs: https://docs.gitlab.com/omnibus/settings/smtp.html
###! **Use smtp instead of sendmail/postfix.**

gitlab_rails['smtp_enable'] = {{ smtp_enable }}
{% if smtp_enable == "true" %}
gitlab_rails['smtp_address'] = "{{ smtp_address }}"
gitlab_rails['smtp_port'] = {{ smtp_port }}
{% if smtp_user_name is defined and smtp_user_name|length %}
gitlab_rails['smtp_user_name'] = "{{ smtp_user_name }}"
gitlab_rails['smtp_password'] = "{{ smtp_password }}"
{% endif %}
gitlab_rails['smtp_domain'] = "{{ smtp_domain }}"
gitlab_rails['smtp_authentication'] = "{{ smtp_authentication }}"
gitlab_rails['smtp_enable_starttls_auto'] = {{ smtp_enable_starttls_auto }}
gitlab_rails['smtp_tls'] = {{ smtp_tls }}

{% if smtp_openssl_verify_mode != "none" %}
###! **Can be: 'none', 'peer', 'client_once', 'fail_if_no_peer_cert'**
###! Docs: http://api.rubyonrails.org/classes/ActionMailer/Base.html
gitlab_rails['smtp_openssl_verify_mode'] = '{{ smtp_openssl_verify_mode }}'

gitlab_rails['smtp_ca_path'] = "{{ smtp_ca_path }}"
gitlab_rails['smtp_ca_file'] = "{{ smtp_ca_file }}"
{% endif %}
{% endif %}

################################################################################
## Container Registry settings
##! Docs: https://docs.gitlab.com/ee/administration/container_registry.html
################################################################################
gitlab_rails['registry_enabled'] = {{ registry_enabled }}

registry_external_url '{{ registry_external_url }}'

### Settings used by GitLab application
gitlab_rails['registry_host'] = "{{ registry_host }}"
gitlab_rails['registry_port'] = "{{ registry_port }}"
gitlab_rails['registry_path'] = "{{ registry_path }}"

# Notification secret, it's used to authenticate notification requests to GitLab application
# You only need to change this when you use external Registry service, otherwise
# it will be taken directly from notification settings of your Registry
gitlab_rails['registry_notification_secret'] = {{ registry_notification_secret }}

###! **Do not change the following 3 settings unless you know what you are
###!   doing**
gitlab_rails['registry_key_path'] = "{{ registry_key_path }}"
gitlab_rails['registry_issuer'] = "{{ registry_issuer }}"

### Settings used by Registry application
registry['enable'] = {{ registry_app_enabled }}
registry['dir'] = "{{ registry_dir }}"
registry['registry_http_addr'] = "{{ registry_http_addr }}"
registry['debug_addr'] = "{{ registry_debug_addr }}"
registry['env_directory'] = "{{ registry_env_directory }}"
registry['env'] = {
{% for key, value in registry_environment_variables %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}
registry['log_level'] = "{{ registry_log_level }}"
registry['log_formatter'] = "{{ registry_log_formatter }}"
registry['rootcertbundle'] = "{{ registry_rootcertbundle }}"
registry['health_storagedriver_enabled'] = {{ registry_health_storagedriver_enabled }}
registry['storage_delete_enabled'] = {{ registry_storage_delete_enabled }}
registry['validation_enabled'] = {{ registry_validation_enabled }}
registry['autoredirect'] = {{ registry_autoredirect }}
registry['compatibility_schema1_enabled'] = {{ registry_compatibility_schema1_enabled }}

{% if registry_storage.enabled %}
### Registry backend storage
###! Docs: https://docs.gitlab.com/ee/administration/container_registry.html#container-registry-storage-driver
registry['storage'] = {
 '{{ registry_storage.type }}' => {
    'accesskey' => '{{ registry_storage.accesskey }}',
    'secretkey' => '{{ registry_storage.secretkey }}',
    'region' => '{{ registry_storage.region }}',
    'bucket' => '{{ registry_storage.bucket }}'
  }
}

{% endif %}

################################################################################
## Registry NGINX
################################################################################

# All the settings defined in the "GitLab Nginx" section are also available in
# this "Registry NGINX" section, using the key `registry_nginx`.  However, those
# settings should be explicitly set. That is, settings given as
# `nginx['some_setting']` WILL NOT be automatically replicated as
# `registry_nginx['some_setting']` and should be set separately.

# Below you can find settings that are exclusive to "Registry NGINX"
registry_nginx['enable'] = {{ registry_nginx_enable }}

{% if registry_nginx_enable == "true" %}
registry_nginx['proxy_set_headers'] = {
{% for key, value in registry_nginx_proxy_headers.items() %}
 "{{ key }}" => "{{ value }}",
{% endfor %}
}

registry_nginx['ssl_certificate'] = "{{ registry_nginx_ssl_certificate }}"
registry_nginx['ssl_certificate_key'] = "{{ registry_nginx_ssl_certificate_key }}"

# When the registry is automatically enabled using the same domain as `external_url`,
# it listens on this port
registry_nginx['listen_port'] = {{ registry_external_url_port }}

{% endif %}

################################################################################
### Reply by email
################################################################################
###! Allow users to comment on issues and merge requests by replying to
###! notification emails.
###! Docs: https://docs.gitlab.com/ee/administration/reply_by_email.html
gitlab_rails['incoming_email_enabled'] = {{ gitlab_rails_incoming_email_enabled }}

#### Incoming Email Address
####! The email address including the `%{key}` placeholder that will be replaced
####! to reference the item being replied to.
####! **The placeholder can be omitted but if present, it must appear in the
####!   "user" part of the address (before the `@`).**
gitlab_rails['incoming_email_address'] = "{{ gitlab_rails_incoming_email_address }}"

#### Email account username
####! **With third party providers, this is usually the full email address.**
####! **With self-hosted email servers, this is usually the user part of the
####!   email address.**
gitlab_rails['incoming_email_email'] = "{{ gitlab_rails_incoming_email_email }}"

#### Email account password
gitlab_rails['incoming_email_password'] = "{{ gitlab_rails_incoming_email_password }}"

#### IMAP Settings
gitlab_rails['incoming_email_host'] = "{{ gitlab_rails_incoming_email_host }}"
gitlab_rails['incoming_email_port'] = {{ gitlab_rails_incoming_email_port }}
gitlab_rails['incoming_email_ssl'] = {{ gitlab_rails_incoming_email_ssl }}
gitlab_rails['incoming_email_start_tls'] = {{ gitlab_rails_incoming_email_start_tls }}

#### Incoming Mailbox Settings (via `mail_room`)
####! The mailbox where incoming mail will end up. Usually "inbox".
gitlab_rails['incoming_email_mailbox_name'] = "{{ gitlab_rails_incoming_email_mailbox_name }}"
####! The IDLE command timeout.
gitlab_rails['incoming_email_idle_timeout'] = {{ gitlab_rails_incoming_email_idle_timeout }}
####! The file name for internal `mail_room` JSON logfile
gitlab_rails['incoming_email_log_file'] = "{{ gitlab_rails_incoming_email_log_file }}"

#######################################
###       Redis configuration       ###
#######################################
### AWS ElastiCache Configuration
gitlab_rails['redis_host'] = "{{ redis_host }}"
gitlab_rails['redis_port'] = {{ redis_port}}
gitlab_rails['redis_ssl'] = {{ redis_ssl }}
gitlab_rails['redis_password'] = "{{ redis_password }}"

################################################################################
## Prometheus Node Exporter
##! Docs: https://docs.gitlab.com/ee/administration/monitoring/prometheus/node_exporter.html
################################################################################

node_exporter['enable'] = {{ node_exporter_enable }}
{% if node_exporter_enable == "true" %}
node_exporter['home'] = '{{ node_exporter_home }}'
node_exporter['log_directory'] = '{{ node_exporter_log_directory }}'
node_exporter['flags'] = {
{% for key, value in node_exporter_flags.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}
node_exporter['env_directory'] = '{{ node_exporter_env_directory }}'
node_exporter['env'] = {
{% for key, value in node_exporter_environment_variables.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}

##! Advanced settings. Should be changed only if absolutely needed.
node_exporter['listen_address'] = '{{ node_exporter_listen_address }}'
{% endif %}

{% if gitlab_workhorse_enable == "true" %}
#######################################
### GitLab Workhorse configuration  ###
#######################################
gitlab_workhorse['ha'] = {{ gitlab_workhorse_ha }}
gitlab_workhorse['listen_network'] = "{{ gitlab_workhorse_listen_network }}"
gitlab_workhorse['listen_umask'] = {{ gitlab_workhorse_listen_umask }}
gitlab_workhorse['listen_addr'] = "{{ gitlab_workhorse_listen_addr }}"
gitlab_workhorse['auth_backend'] = "{{ gitlab_workhorse_auth_backend }}"

##! the empty string is the default in gitlab-workhorse option parser
gitlab_workhorse['auth_socket'] = "{{ gitlab_workhorse_auth_socket }}"

##! put an empty string on the command line
gitlab_workhorse['pprof_listen_addr'] = "{{ gitlab_workhorse_pprof_listen_addr }}"

gitlab_workhorse['prometheus_listen_addr'] = "{{ gitlab_workhorse_prometheus_listen_addr }}"

gitlab_workhorse['dir'] = "{{ gitlab_workhorse_dir }}"
gitlab_workhorse['log_directory'] = "{{ gitlab_workhorse_log_directory }}"
gitlab_workhorse['proxy_headers_timeout'] = "{{ gitlab_workhorse_proxy_headers_timeout }}"

##! limit number of concurrent API requests, defaults to 0 which is unlimited
gitlab_workhorse['api_limit'] = {{ gitlab_workhorse_api_limit }}

##! limit number of API requests allowed to be queued, defaults to 0 which
##! disables queuing
gitlab_workhorse['api_queue_limit'] = {{ gitlab_workhorse_api_queue_limit }}

##! duration after which we timeout requests if they sit too long in the queue
gitlab_workhorse['api_queue_duration'] = "{{ gitlab_workhorse_api_queue_duration }}"

##! Long polling duration for job requesting for runners
gitlab_workhorse['api_ci_long_polling_duration'] = "{{ gitlab_workhorse_api_ci_long_polling_duration }}"

##! Log format: default is text, can also be json or none.
gitlab_workhorse['log_format'] = "{{ gitlab_workhorse_log_format }}"

gitlab_workhorse['env_directory'] = "{{ gitlab_workhorse_env_directory }}"
gitlab_workhorse['env'] = {
{% for key, value in gitlab_workhorse_environment_variables.items() %}
  '{{ key }}' => "{{ value }}",
{% endfor %}
}
{% endif %}

################################################################################
## GitLab Puma
##! Tweak puma settings. You should only use Unicorn or Puma, not both.
##! Docs: https://docs.gitlab.com/omnibus/settings/puma.html
################################################################################

puma['enable'] = {{ puma_enable }}
{% if puma_enable == "true" %}
puma['worker_timeout'] = {{ puma_worker_timeout }}
puma['worker_processes'] = {{ puma_worker_processes }}
puma['min_threads'] = {{ puma_min_threads }}
puma['max_threads'] = {{ puma_max_threads }}

### Advanced settings
puma['listen'] = '{{ puma_listen }}'
puma['port'] = {{ puma_port }}
puma['socket'] = '{{ puma_socket }}'
puma['pidfile'] = '{{ puma_pidfile }}'
puma['state_path'] = '{{ puma_state_path }}'

###! **We do not recommend changing this setting**
puma['log_directory'] = "{{ puma_log_directory }}"

### **Only change these settings if you understand well what they mean**
###! Docs: https://github.com/schneems/puma_worker_killer
puma['per_worker_max_memory_mb'] = {{ puma_per_worker_max_memory_mb }}

puma['exporter_enabled'] = {{ puma_exporter_enabled }}
puma['exporter_address'] = "{{ puma_exporter_address }}"
puma['exporter_port'] = {{ puma_exporter_port }}
{% endif %}

#######################################
###      Sidekiq configuration      ###
#######################################
sidekiq['enable'] = {{ sidekiq_enable }}
{% if sidekiq_enable == "true" %}
sidekiq['log_directory'] = "{{ sidekiq_log_directory }}"
sidekiq['log_format'] = "{{ sidekiq_log_format }}"
sidekiq['shutdown_timeout'] = {{ sidekiq_shutdown_timeout }}
# Set number of Sidekiq threads per queue process to the recommend number of 10
sidekiq['concurrency'] = {{ sidekiq_concurrency }}
# Set number of Sidekiq queue processes to the same number as available CPUs
sidekiq['queue_groups'] = {{ sidekiq_queue_groups }}
sidekiq['metrics_enabled'] = {{ sidekiq_metrics_enabled }}
sidekiq['listen_address'] = "{{ sidekiq_listen_address }}"
sidekiq['listen_port'] = {{ sidekiq_listen_port }}
sidekiq['health_checks_enabled'] = {{ sidekiq_health_checks_enabled }}
sidekiq['health_checks_listen_address'] = "{{ sidekiq_health_checks_listen_address }}"
sidekiq['health_checks_listen_port'] = {{ sidekiq_health_checks_listen_port }}
{% endif %}

#######################################
###        KAS configuration        ###
#######################################
##! Enable GitLab KAS
gitlab_kas['enable'] = {{ gitlab_kas_enabled }}
{% if gitlab_kas_enabled == "true" %}
gitlab_rails['gitlab_kas_external_url'] = '{{ gitlab_rails_gitlab_kas_external_url }}'
gitlab_rails['gitlab_kas_internal_url'] = '{{ gitlab_rails_gitlab_kas_internal_url }}'

##! Agent configuration for GitLab KAS
gitlab_kas['agent_configuration_poll_period'] = {{ gitlab_kas_agent_configuration_poll_period }}
gitlab_kas['agent_gitops_poll_period'] = {{ gitlab_kas_agent_gitops_poll_period }}
gitlab_kas['agent_gitops_project_info_cache_ttl'] = {{ gitlab_kas_agent_gitops_project_info_cache_ttl }}
gitlab_kas['agent_gitops_project_info_cache_error_ttl'] = {{ gitlab_kas_agent_gitops_project_info_cache_error_ttl}}
gitlab_kas['agent_info_cache_ttl'] = {{ gitlab_kas_agent_info_cache_ttl }}
gitlab_kas['agent_info_cache_error_ttl'] = {{ gitlab_kas_agent_info_cache_error_ttl }}

##! Shared secret used for authentication between KAS and GitLab
# gitlab_kas['api_secret_key'] = nil # Will be generated if not set. Base64 encoded and exactly 32 bytes long.

##! Listen configuration for GitLab KAS
gitlab_kas['listen_address'] = '{{ gitlab_kas_listen_address }}'
gitlab_kas['listen_network'] = '{{ gitlab_kas_listen_network}}'
gitlab_kas['listen_websocket'] = {{ gitlab_kas_listen_websocket }}
gitlab_kas['internal_api_listen_network'] = '{{ gitlab_kas_internal_api_listen_network }}'
gitlab_kas['internal_api_listen_address'] = '{{ gitlab_kas_internal_api_listen_address}}'

##! Metrics configuration for GitLab KAS
gitlab_kas['metrics_usage_reporting_period'] = {{ gitlab_kas_metrics_usage_reporting_period }}

##! Directories for GitLab KAS
gitlab_kas['dir'] = '{{ gitlab_kas_dir }}'
gitlab_kas['log_directory'] = '{{ gitlab_kas_log_directory }}'
gitlab_kas['env_directory'] = '{{ gitlab_kas_env_directory }}'
{% endif %}

### Disable components that will not be on the GitLab application server
gitaly['enable'] = {{ gitaly_enabled }}

################################################################################
## Prometheus Gitlab exporter
##! Docs: https://docs.gitlab.com/ee/administration/monitoring/prometheus/gitlab_exporter.html
################################################################################

gitlab_exporter['enable'] = {{ gitlab_exporter_enabled }}
{% if gitlab_exporter_enabled == "true" %}
gitlab_exporter['log_directory'] = "{{ gitlab_exporter_log_directory }}"
gitlab_exporter['home'] = "{{ gitlab_exporter_home }}"

##! Advanced settings. Should be changed only if absolutely needed.
gitlab_exporter['listen_address'] = '{{ gitlab_exporter_listen_address }}'
gitlab_exporter['listen_port'] = '{{ gitlab_exporter_listen_port }}'

##! Manage gitlab-exporter sidekiq probes. false by default when Sentinels are
##! found.
gitlab_exporter['probe_sidekiq'] = {{ gitlab_exporter_probe_sidekiq }}
{% endif %}